<?
/*######################################
CLASS_MYSQL.INC

Zentrale Klasse fuer Mysql-Operationen

Setzt voraus, dass folgende Konstanten gesetzt sind

G_HOST  Mysql-Host
G_DBUSER  Mysql-Username
G_DBPWD  Mysql-Passwort

Fuer alle verwendeten Konstanten  
-> config.inc
-> standard.inc
########################################*/

class Errors {
/*######  SQLError #######################
Uebergeben:
$mysqlerror : fehlermeldung aus mysql_error()
$statement : Mysql-Statement, das den fehler verursacht hat.
$used_db : Benutzte DB

Rueckgabe: echo der fehlermeldung
#########################################*/
  function SQLError($mysqlerror,$statement,$used_db)
    {
    if(G_DEBUG == 1)  {
      $out = "&nbsp;<p />
        <center>
          <table style='border:2px solid #c00;padding:4px; margin:4px'>
              <tr>
                <th style='text-align:left;color:#c00;font-face:bold;font-size:1.4em'>The following database Error occured:</th>
              </tr>
              <tr>
                 <td>$mysqlerror</TD>
              </tr>
              <tr>
                <th style='text-align:left;color:#c00;font-face:bold;font-size:1.2em'>Statement:</th>
              </tr>
              <tr>
                 <td>$statement<P>in $used_db</td>
              </tr>
            </table>
          </center>";
      echo $out;
      }
    else  {
      echo "---- Database error ----";
      }
    exit;        
    }
  
  }

class FastSql extends Errors{
  var $Link_ID = 0;
  var $DBname = 0;
  var $DBHost = "";
  var $DBUser = "";
  var $DBPwd = "";
  var $DBPort = "";
/*######  connect #######################
Wenn $LinkID nicht gesetzt ist, wird eine
verbindung zum definierten DB-Server aufgebaut

Rueckgabe: echo der fehlermeldung
#########################################*/
  function connect()
    {
    if ($this->DBHost == '')  $this->DBHost = G_HOST;
    if ($this->DBPort != '')  $this->DBHost = $this->DBHost.":".$this->DBPort;
    if ($this->DBUser == '')  $this->DBUser = G_DBUSER;
    if ($this->DBPwd == '')   $this->DBPwd = G_DBPWD;

    if(!$this->Link_ID = @mysql_connect($this->DBHost, $this->DBUser, $this->DBPwd))
      $this-> SQLError(mysql_error(),'no',$db);
    }

/*######  setDb   #######################
Fuellt $this->Dbname mit dem ergebnis 
der Datenbankverbindung zu 
$db

Bei $db handelt es sich i.d.R. um die 
Konstante G_NORMDB
#########################################*/
  function setDb($db)
    {
    if(!$this->DBname = @mysql_selectdb($db))  $this-> SQLError(mysql_error(),'keine DB gefunden',$db);
    }

/*######  query   #######################
Fhrt Select durch und gibt Array mit den treffern zurck; 
es werden nur die Verbalen Keys benutzt (spart Platz)

Das Array besteht aus zwei Leveln.
level 1: Nummern des gefundenen datensatzes
Level 2: Name=>Wert - Paare der Datensatzeintraege

beispiel:
$treffer[0][ID] = 1
$treffer[0][Name] = Horst
$treffer[1][ID] = 2
$treffer[1][name] = Willi
#########################################*/
  function query($query,$db) {
    // Wenn kein Datenbank-Link vorhanden ist, eines herstellen.
    if (!$this->Link_ID) 
      {
      $this->connect();
      }
      $this->setDb($db);
      if(!$result = @mysql_query($query)) $this-> SQLError(mysql_error(),$query,$db);
      while($row = mysql_fetch_array($result,MYSQL_ASSOC))
       {
       $allrows[] = $row;
       }
     return $allrows;
   }
   
/*######  single   #######################
Fuehrt Select durch wie query (->),
gibt aber nur ein einfaches Array mit den Feldern und 
Werten des ersten datensatzes zurueck; 
es werden auch hier  nur die Verbalen Keys benutzt

#########################################*/
  function single($query,$db) {
    // Wenn kein Datenbank-Link vorhanden ist, eines herstellen.
    if (!$this->Link_ID)
      $this->connect();
      $this->setDb($db);
      if(!$result = @mysql_query($query)) $this-> SQLError(mysql_error(),$query,$db);
      $row = mysql_fetch_array($result,MYSQL_ASSOC);
     return $row;
   }

## Fhrt Update durch und gibt Status zurck
  function update($query,$db) {
    // Wenn kein Datenbank-Link vorhanden ist, eines herstellen.
    if (!$this->Link_ID)
      $this->connect();
      $this->setDb($db);
      if(!$result = @mysql_query($query)) $this-> SQLError(mysql_error(),$query,$db);
      return $result;
  }

## Fhrt Insert durch und gibt Letzte ID zurck
  function insert($query,$db) {
    // Wenn kein Datenbank-Link vorhanden ist, eines herstellen.
    if (!$this->Link_ID)
      $this->connect();
      $this->setDb($db);
      if(!$result = @mysql_query($query)) $this-> SQLError(mysql_error(),$query,$db);
      $id = mysql_insert_id($this->Link_ID);
      return $id;
   }


## Gibt komplettes Explain zurck
  function explain($table,$db) {
    // Wenn kein Datenbank-Link vorhanden ist, eines herstellen.
    if (!$this->Link_ID)
      $this->connect();
      $this->setDb($db);
      if(!$result = @mysql_query("explain $table")) $this-> SQLError(mysql_error(),$query,$db);
      while($row = mysql_fetch_array($result))
       {
       $allrows[] = $row;
       }
     return $allrows;
   }


## Gibt Feldnamen zurck
  function fields($table,$db) {
    // Wenn kein Datenbank-Link vorhanden ist, eines herstellen.
    if (!$this->Link_ID)
      $this->connect();
      if(!$fields = @mysql_list_fields($db,$table,$this->Link_ID)) $this-> SQLError(mysql_error(),$query,$db);
      $cols = mysql_num_fields($fields);
      for ($i = 0; $i < $cols; $i++)
        {
        $fieldarr[] = mysql_field_name($fields, $i);
        }
      return $fieldarr;
  }
  
## Bastelt komplettes INSERT - Statement und setzt es ab.
## bergebene parameter: 
## - Tabelle
## - DB
## - Array Einzugebende werte
## - Array(auszulassende Felder)
## Rueckgabe: Eingefuegte ID, wenn vorhanden
  function MkInsert($table,$db,$ins_vals,$skip=array())  {
      if (!$this->Link_ID)
      $this->connect();
      $fields = $this->fields($table,$db);
      foreach($fields AS $feld)
        {
        if(!in_array($feld,$skip))
          {
          $keys[] = $feld;
          $vals[] = $ins_vals[$feld];
          }  
        }
      $fielddef = implode(",",$keys);
      $valdef = implode("','",$vals);
      $statement = "INSERT INTO $table($fielddef) VALUES('".$valdef."')";
      if($fr = $this->update($statement,$db))
      $nnt = mysql_insert_id($this->Link_ID);
      #return $statement;
      return $nnt;
      }

## Bastelt komplettes UPDATE - Statement und setzt es ab.
## bergebene parameter: 
## - Tabelle
## - DB
## - Array Einzugebende werte
## - Abzugleichender Wert ("WHERE"-Bedingung;idealerweise ID-Nummer)
## - Array(auszulassende Felder)
  function MkUpdate($table,$db,$upd_vals,$upd_comp,$skip=array())  {
      if (!$this->Link_ID)
      $this->connect();
      $fields = $this->fields($table,$db);
      foreach($fields AS $feld)
        {
        if(!in_array($feld,$skip))
          {
          $updd[] = $feld."='".$upd_vals[$feld]."'";
          }  
        }
      $fielddef = implode(",",$updd);
      $statement = "UPDATE $table SET $fielddef WHERE $upd_comp='".$upd_vals[$upd_comp]."'";
     
      if($fr = $this->update($statement,$db))
      return $statement;
      else return $statement;
      #return $fields;
      }


}

?>
