<?
/*#######################################
DATE.FNC
Tobi Schulz 2003 (central@samedia.net)


MakeDate
-------------------------------------
Builds a readable Date string from a timestamp 
or SQL Date/DateTime String

Input:
$date = The date string to convert
$mask = Output style
You can use the letters:
y = Year (yy or yyyy)
m = month
d = day
h = hour
i = minute
s = second
-- f.e. "mm/dd/yyyy" or "dd.mm.YYY hh:ii:ss"
########################################*/

function MakeDate($date, $mask)
  {
  chop($date);
  $mask = strtolower($mask);
  
  // what type of input date do we have?

//Mysql-Timestamp or Mysql-DATETIME:
  if(ereg("([0-9]{4})([0-9]{2})([0-9]{2})([0-9]{2})([0-9]{2})([0-9]{2})", $date, $cc) || ereg("^([0-9]{4})-([0-9]{2})-([0-9]{2}) ([0-9]{2}):([0-9]{2}):([0-9]{2})$", $date, $cc))  
    {
    $yyyy = $cc[1];
    $mm = $cc[2];
    $dd = $cc[3];
    $hh = $cc[4];
    $ii = $cc[5];
    $ss = $cc[6];
    }
    
//UNIX - Timestamp :
  else if(strlen($date) <= 10 && is_numeric($date))  
    {
    $date = date("YmdHis",$date);
    return MakeDate($date, $mask);
    }

//Mysql-DATE
  else if(ereg("^([0-9]{4})-([0-9]{2})-([0-9]{2})$", $date, $cc))  
    {
    $yyyy = $cc[1];
    $mm = $cc[2];
    $dd = $cc[3];
    $hh = "00";
    $ii = "00";
    $ss = "00";
    }
  else 
    {
    return "Unsupported Input Format: $date";
    }
    
  $mask = ereg_replace("y{4}",$yyyy, $mask);
  $mask = ereg_replace("y{2}",substr($yyyy,2,2), $mask);
  $mask = ereg_replace("m{2}",$mm, $mask);
  $mask = ereg_replace("m{1}",ereg_replace("^0","",$mm), $mask);
  $mask = ereg_replace("d{2}",$dd, $mask);
  $mask = ereg_replace("d{1}",ereg_replace("^0","",$dd), $mask);
  $mask = ereg_replace("h{2}",$hh, $mask);
  $mask = ereg_replace("h{1}",ereg_replace("^0","",$hh), $mask);
  $mask = ereg_replace("i{2}",$ii, $mask);
  $mask = ereg_replace("i{1}",ereg_replace("^0","",$ii), $mask);
  $mask = ereg_replace("s{2}",$ss, $mask);
  $mask = ereg_replace("s{1}",ereg_replace("^0","",$ss), $mask);
  
  return $mask;
  }