<?
# parser.inc
# Stefan Reich (Teile von Tobi Schulz bernommen)
# Template-Parser mit neuem Interface

class Parser2 {
  # Auf Variablen NICHT von aussen zugreifen! (Nur Methoden verwenden.)
  var $params = array();
  var $template, $output;

  ########################################################
  ################## INTERNE FUNKTIONEN ##################
  ########################################################
  
  #  getColorchange
  #  Sucht nach dem Vorkommen von <#ATTR <FARBE1>,<FARBE2>#>
  #  Setzt die Variablen $this->rownum (1 oder 2)
  #  sowie $this->ChColor1 und $this->ChColor2
  # Diese werden dann abwechselnd in Tags mit dem Namen <#ATTR#> eingesetzt
  # So lassen sich abwechselnde Farbmuster in Loops erzeugen  
  function getColorchange($templ)
  {
  $pattern = "/<#ATTR ([^#|^>]+)#>/";
  if(preg_match($pattern,$templ,$cont))  {
      if(preg_match("|([^,]+),(.+)|",$cont[1], $arval))  {
        $this->ChColor1 = $arval[1];
        $this->ChColor2 = $arval[2];
        }
      else { $this->ChColor1 = $cont[1]; }
      $this->rownum = 1;
      $templ = preg_replace($pattern, "", $templ);
      }
    
    return($templ);
    }

  #  SetColorchange
  #  liefert die gueltige Farbe 1 oder 2.
  #  Die Variable $this->rownum wird dabei entsprechend gesetzt
  function SetColorchange()
  {
  if($this->rownum ==1) {
    $this->rownum = 2;
    return($this->ChColor1);
    }
  else {
    $this->rownum = 1;
    return($this->ChColor2);
    }
  }

  
  
  ## checkCondition()
  ## Function to check for conditions in IF Tags
  ## Possible conditions:
  #
  #  gt = greater (Numbers only)
  #  ge = greater or equal (Numbers only)
  #  lt = lower (Numbers only)
  #  le = lower or equal (Numbers only)
  #  eq = equal (Number or string)
  #  ne = not equal (Number or string)
  #  lk = existis in string (String only, functions like the 
  #       SQL LIKE '%string%'
  #
  # $value = value to check condition against
  #
  # Benutzte Instanzvariablen: keine
  
  function checkCondition($value, $condition) {
    $cond = split(" ",$condition);
    $chh = $cond[0];
    $wert = $cond[1];
    $wert = ereg_replace("['|\"]","",$wert);
    #echo $wert;
    if($chh == "gt") return ($value >  $wert);
    if($chh == "ge") return ($value >= $wert);
    if($chh == "lt") return ($value <  $wert);
    if($chh == "le") return ($value <= $wert);
    if($chh == "eq") return ($value == $wert);
    if($chh == "ne") return ($value != $wert);
    if($chh == "lk") return eregi($wert,$value);
    return $wert;
  }

  # zerlegt das Template $str in Teilstcke und speichert es in $this->template.
  # In jedem Element ist danach entweder
  # - nur Text
  # - ein HTML-Kommentar
  # - genau ein Parser-Tag
  function splitTemplate($str) {
    $this->template = array();
    while ($str != '') {
      $result = preg_match('/^(.*?)(<#.*?#>|<!--.*?-->|\n?$)/s', $str, $matches);
      if (strlen($matches[1])) $this->template[] = $matches[1];
      if (strlen($matches[2]))
        {
        $match = $this->GetColumns($matches[2]);
        $match = $this->GetcolorChange($match);
        $this->template[] = $match;
        }
      $str = substr($str, strlen($matches[0]));
      if (++$sicherheitscounter >= 2000) {
        print_r($matches);
        die("Parser stuck: '".$str."' $result ".strlen($str));
      }
    }
  }

  # fragt eine Variable oder Konstante ab
  function getvar(&$vars, $var) {
    if (preg_match('/^G_/', $var) && defined($var))
      return constant($var);
    else
      return $vars[$var];
  }
  
  # erzeugt tags fuer mehrspaltiges Layouts in einem <#FOR Tag
  # Dazu muessen innerhalb dieses folgende IOnformationen verfuegbar sein:
  # <#COL_COUNT:$cols#> Anzahl der Spalten
  # <#COL_START:ZEILENANFANG#>
  # <#COL_STOP:ZEILENENDE#>
  # <#COL_FILLER:FUELLSEL#>
  # Letzteres optional fuer den Fall, dass die Anzahl der Durchlaeufe nicht durch 
  # Anzahl der Spalten teilbar ist
  function GetColumns($tag)
    {
    $ct = "/<#COL_COUNT_([^\:]+):([0-9]+)#>/";
    if(preg_match($ct, $tag, $matches))  {
        $this->cols[IDENT] = $matches[1];
        $this->cols[COUNTER] = $matches[2];
        $tag = preg_replace("/<#COL_COUNT_".$matches[1].":".$matches[2]."#>/","<!--COLS:".$matches[2]."-->",$tag);
        }
    $tagstocheck = array("START", "STOP", "FILLER");
    foreach($tagstocheck as $mark)  {
      $begin = "|<#COL_".$mark.":(.+)#>$|";
      if(preg_match($begin, $tag, $matches))  {
        $this->cols[$mark] = $matches[1]; 
        }          
      }
     $end = "|<#/COL_COUNT#>|";
    if(preg_match($end, $tag))  {
        $tag = preg_replace($end,"<!--COLS:ENDE-->",$tag);
        }
    return $tag;
    }
  #Setzt Zeilenende und-anfang fuer mehrspaltiges Layout
  function SetColumns($lines)
    {
    if($this->cols[COUNTER] == '') return $lines;    
    $sch = 0;
    $var = $this->getvar($this->params,$this->cols[IDENT]);
    $iterate = count($var);
    foreach($lines AS $line)  {
      if(preg_match("/<!--COLS:".$this->cols[COUNTER]."-->/",$line))  {
        if($sch ==  0 || is_int(($sch) / $this->cols[COUNTER]))
          $out[] = "<!--STARTBLOCK-->".$this->cols[START];      
        $sch++;
        }
      elseif(preg_match("/<!--COLS:ENDE-->/",$line) && is_int(($sch) / $this->cols[COUNTER])) {
        $out[] = $this->cols[STOP];
        }
      elseif(preg_match("/<!--COLS:ENDE-->/",$line) && ($sch) == $iterate) {
        $neardown = floor($iterate / $this->cols[COUNTER]);
        $rest = $this->cols[COUNTER] + ($neardown * $this->cols[COUNTER]) - $iterate;
        for($rr = 0;$rr < $rest;$rr++)  {
          $lastline .= $this->cols[FILLER];
          }
        $out[] = $lastline .$this->cols[STOP];
        }
      else {
        $out[] = $line;
        }
      }
    return $out;
    }
  
  # bearbeitet die Eintrge $this->template[$from] bis $this->template[$to-1]
  # mit den Parametern $vars und hngt das Ergebnis an $this->output an
  function process($from, $to, $vars) {
    for ($i = $from; $i < $to; $i++) {
      
      $p = $this->template[$i];
      if (preg_match("/^<#FOR (.*)#>/", $p, $matches)) {
        $forl = 0;
        # Ende des FOR-Tags finden
        $var = $matches[1];
        $value = $this->getvar($vars, $var);
        $j = ++$i;
        while ($j < $to && $this->template[$j] != "<#/FOR $var#>")
          {
          ++$j;
          }
        # rekursiv process() aufrufen (fr jede Zeile)
        if (is_array($value)) foreach ($value as $row)
          $this->process($i, $j, $row + $vars);
          
        # Nach dem schlieenden Tag weitermachen
        $i = $j;
      } elseif (preg_match('/^<#IF (.*)?#>/', $p, $matches)) {
        # Tag zerlegen
        $var = $matches[1];
        $cond = '';
        if (preg_match('/(\S*)\s+\(?(.*?)\)?$/', $var, $matches)) {
          $var = $matches[1];
          $cond = $matches[2];
        }
        $value = $this->getvar($vars, $var);
        if ($cond) $value = $this->checkCondition($value, $cond);
        
        # Ende des IF-Tags finden
        $j = ++$i;
        while ($j < $to && $this->template[$j] != "<#/IF $var#>") ++$j;
        
        # rekursiv process() aufrufen, falls Variable gesetzt
        if ($value)
          $this->process($i, $j, $vars);
          
        # Nach dem schlieenden Tag weitermachen
        $i = $j;
      } elseif (preg_match("/^<#ATTR#>/", $p, $matches)) {
        # Variablen-Wert ausgeben
        $this->output[] = preg_replace("/^<#ATTR#>/",$this->SetColorChange(),$p);
      } elseif (preg_match("/^<#(.*)#>/", $p, $matches)) {
        # Variablen-Wert ausgeben
        $this->output[] = $this->getvar($vars, $matches[1]);
      } else { # Normaler Text
        $this->output[] = $p;
      }
    }
  }

  ## Prints PHP code to the output page
  function CheckPHP($text) {
  eval('?>'.$text.'<?'); 
  }

  ########################################################
  ################ FFENTLICHE FUNKTIONEN ################
  ########################################################
  
  # liefert alle gesetzten Parameter
  function getParams() {
    return $this->params;
  }
  
  # liefert EINEN gesetzten Parameter
  function getParam($name) {
    return $this->params[$name];
  }

  # setzt einen Parameter
  function setParam($name, $value) {
    $this->params[$name] = $value;
  }
  
  # setzt mehrere Parameter auf einmal
  function setParams($params) {
    if (is_array($params)) $this->params = $params + $this->params;
  }
  
  # lscht alle Parameter (ohne Argument)
  # bzw. eine Liste von Parametern aus einem Array
  # (die Parameter knnen Key oder Value sein)
  function clearParams($array = 'all') {
    if ($array == 'all')
      $this->params = array();
    else {
      foreach ($array as $k => $v) {
        unset($this->params[$k]);
        unset($this->params[$v]);
      }
    }
  }
  
  # lscht einen Parameter
  function clearParam($name) {
    unset($this->params[$name]);
  }
  
  # Template aus Rahmen und Fragmenten zusammenbauen
  function assemble($frame, $frags) {
    $tmpl = join('', file($frame));
    foreach ($frags AS $fragname => $fragpath) {
      $cmd = "|<!--INSERT_$fragname-->|";
      if (preg_match($cmd, $tmpl)) {
  	    $tmpl = preg_replace($cmd, join('', file($fragpath)), $tmpl);
      }
    }
    $this->splitTemplate($tmpl);
  }
  
  # Template laden (ohne Rahmen)
  function setTemplate($tmpl) {
    $this->splitTemplate(join('', file($tmpl)));
  }
  
  # Setzt den Template-Inhalt direkt (nicht aus Datei)
  function setTemplateText($text) {
    $this->splitTemplate($text);
  }
  
  # Template parsen und Ergebnis zurckliefern
  function parseAndReturn() {
    $this->output = array();
    $this->process(0, count($this->template), $this->params);
    $this->output = $this->SetColumns($this->output);
    return join('', $this->output);
  }
  
  # Template parsen und Ergebnis mit echo ausgeben
  function parseAndEcho() {
    echo $this->parseAndReturn();
  }
  
  # Template parsen und Ergebnis mit echo ausgeben;
  # dabei PHP-Quelltext umwandeln
  function parseAndEchoPHP() {
    $this->CheckPHP($this->parseAndReturn());
  }
  
  # Template parsen und Ergebnis in Datei $file speichern
  function parseAndSave($file) {
    $outf = fopen($file, "w");
    fputs($outf, $this->parseAndReturn());
    fclose($outf);
  }
  
  ########################################################
  ################# STATISCHE FUNKTIONEN #################
  ########################################################
  
  # macht alles in einem Rutsch: assemble und parseAndEcho
  function assembleAndEcho($frame, $frags, $params) {
    $parser = new Parser2;
    $parser->assemble($frame, $frags);
    $parser->setParams($params);
    $parser->parseAndEcho();
  }
  
} # Ende class Parser2
?>
